

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}

local wd
local x = 0
local value = 0
local valueCoefficient = 1
local coefficient = 1


--///////////////////////////////////
                                 --//
local vibrationSpeed = 50        --// <-- The speed of vibration it can't go higher than the max vibration speed
local maxVibrationSpeed = 65     --// <-- The maximum vibration speed
                                 --// - Edit these values
local vehicleSpeedVibration = 10 --// <-- Lower value mean vehicle require less speed to reach the maxVibrationSize, higher value mean you need higher speed to reach maxVibrationSize
local maxVibrationSize = 1.5     --// <-- Minimum 0.2 - It's a multiplier, it mean 2 = 2 times more vibration size than the vibration size
                                 --//
--///////////////////////////////////

local function onUpdate(dt)

	
	for wi,wd in pairs(wheels.wheels) do -- Some values
		local w = wd.obj
		wheelvibrationmod.wd = wd
		wheelvibrationmod.wheelspeed = math.abs(w.angularVelocity * wd.radius)			
	end	

	wd = wheelvibrationmod.wd
	
	if wd ~= nil then
		if wd.contactMaterialID1 == 18 or wd.contactMaterialID1 == 15 or wd.contactMaterialID1 == 20 and wd.contactMaterialID2 == 4 then -- If driving on dirt
		
			valueCoefficient = wheelvibrationmod.wheelspeed/vehicleSpeedVibration -- Vibration size
			if valueCoefficient > maxVibrationSize then valueCoefficient = maxVibrationSize end
			if valueCoefficient < 0.1 then valueCoefficient = 0 end		
			value = math.cos(x)*valueCoefficient
			
			coefficient = vibrationSpeed+wheelvibrationmod.wheelspeed -- Vibration speed
			if coefficient > maxVibrationSpeed then coefficient = maxVibrationSpeed end -- Avoid going to high
			x = x + dt*coefficient -- With DT so it always have the same speed even with slow computer
			if x > 32766 then x = 0 end -- Avoid X going to high if the game is running for much time
		
		end
	end
	
end

local function wheel()
	return value -- Return the final value
end

M.wheel              = wheel
M.updateGFX	    	 = onUpdate

return M